Ruby - Bug #3022

What are $. and ARGF.lineno ?
03/27/2010 04:13 AM - marcandre (Marc-Andre Lafortune)

Status: Closed

Priority: Normal

Assignee: drbrain (Eric Hodel)

Target version: 2.0.0

ruby -v: ruby 1.9.2dev (2010-03-03 trunk 26805) |Backport:
[x86_64-darwin10.2.0]

Description

=begin

1. 8. is not officially documented.
This makes it difficult to know if it works as expected or not...

The Ruby Prog Language (Flanagan & Matz) states:
"The number of the last line read from the current input file. Equivalent to ARGF.lineno."

This is not true in trunk, as demonstrated by:

$ rubydev -e "

ARGF.gets

File.open('/etc/passwd'){|f| f.gets; f.gets}
p $., ARGF.lineno

" /etc/hosts

2

1

What is the "current input file"? Not clear, but it's not thread local, as shown:
$ rubydev -e "
ps.
Thread.new{File.open('/etc/passwd’).gets; p $. }.join;
p$.
0
1
1
1. ARGF.lineno does not conform to its doc.

The doc states:

Returns the current line number of the current file in ARGF. This value
can be set manually with ARGF.lineno=.

Reading this, | would expect ARGF.lineno to be the same as ARGF.to_io.lineno.

That is not the case:

rubydev -e 'p "#{ARGF.lineno} #{ARGF.to_io.lineno}" while ARGF.gets' /etc/hosts /etc/passwd
o

:'és 1"

"26 2"

1. Maybe the best definition would be that $. returns the number of line read operations issued, from the last time an IO was read
in the current thread?
2. | suggest the documentation of ARGF.lineno be changed to:

Returns the current line number of ARGF as a whole. This value
can be set manually with ARGF.lineno=.

See also [ruby-core:26303]

=end

Associated revisions

Revision 118d9f43c8f2e1665fb6ebac751299a852072133 - 11/27/2012 11:57 PM - zzak (zzak _)

¢ doc/globals.rdoc: Add documentation file for magic globals
[ruby-core:29048] [Bug #3022]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37913 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 118d9f43 - 11/27/2012 11:57 PM - zzak (zzak _)

¢ doc/globals.rdoc: Add documentation file for magic globals
[ruby-core:29048] [Bug #3022]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37913 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/12/2010 08:44 PM - mame (Yusuke Endoh)

- Assignee set to marcandre (Marc-Andre Lafortune)

=begin
Hi,

2010/3/27 Marc-Andre Lafortune redmine@ruby-lang.org:

This is not true in trunk, as demonstrated by:

$ rubydev -e "

ARGF.gets

File.open('/etc/passwd'){|f| f.gets; f.gets}
p $., ARGF.lineno

" /etc/hosts

2

1

This can be fixed easily, but | guess it will cause compatibility
issue. In fact, by the fix, rubyspec and make test-all reports
some errors. So | think we should consider the current behavior
as spec:

Returns the number of the last line read by Kernel#gets, |O#gets
or ARGF#gets. This variable has global scope, and can be assigned
an integer manually.
1. | suggest the documentation of ARGF.lineno be changed to:
Returns the current line number of ARGF as a whole. This value

can be set manually with ARGF.lineno=.

Looks good. Could you commit it with the doc | wrote together?

Yusuke Endoh mame@tsg.ne.jp

=end

#2 - 06/22/2010 02:47 PM - marcandre (Marc-Andre Lafortune)
- Status changed from Open to Closed
- % Done changed from 0 to 100

06/16/2025

2/4
mailto:redmine@ruby-lang.org
mailto:mame@tsg.ne.jp

=begin

This issue was solved with changeset r28381.

Marc-Andre, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

=end

#3 - 06/22/2010 02:58 PM - marcandre (Marc-Andre Lafortune)
- Status changed from Closed to Open

=begin
Writing "cf." in the commit log is not recognized correctly, but "cf", "c.f." or "c.f" are.

Since "cf." is the correct way to write it, could anyone with the right access fix it (Yugui?)

Thanks, and sorry for the noise
Marc-André

=end

#4 - 06/23/2010 11:23 PM - mame (Yusuke Endoh)

- Assignee deleted (marcandre (Marc-Andre Lafortune))

- Priority changed from Normal to 3

- Target version changed from 1.9.2 to 2.0.0

=begin
Hi,
1. $. is not officially documented.
As far as | know, rdoc does not support documents for built-in
variables. So there is no way to document them.
We should first add the feature to rdoc, or add a new document

about ruby's basic semantics. Contribution is welcome.

Yusuke Endoh mame@tsg.ne.jp

=end

#5 - 06/26/2011 02:47 PM - naruse (Yui NARUSE)
- Status changed from Open to Assigned

- Assignee set to drbrain (Eric Hodel)
Eric, how do we document $.?

#6 - 06/27/2011 02:08 AM - steveklabnik (Steve Klabnik)

Perl actually keeps a separate document to explain these variables, 'Perlvar' http://perldoc.perl.org/perlvar.html

#7 - 07/09/2011 09:26 AM - drbrain (Eric Hodel)

- Category changed from core to doc

| will need to add support to RDoc for global variables, | don't have time to add the feature for 1.9.3.

ARGF.lineno is documented now.

#8 - 11/28/2012 08:57 AM - zzak (zzak _)

- Status changed from Assigned to Closed

This issue was solved with changeset r37913.
Marc-Andre, thank you for reporting this issue.
Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

e doc/globals.rdoc: Add documentation file for magic globals
[ruby-core:29048] [Bug #3022]
